import { type QueryComparisonOptions, type QueryWhereMap, type QueryOptions, type QueryWhereFieldOperatorMap, type Type, type FieldKey, type Scalar, type QueryConflictPaths } from 'nukak/type';
import { AbstractSqlDialect } from 'nukak/dialect';
export declare class PostgresDialect extends AbstractSqlDialect {
    constructor();
    insert<E>(entity: Type<E>, payload: E | E[]): string;
    upsert<E>(entity: Type<E>, conflictPaths: QueryConflictPaths<E>, payload: E): string;
    compare<E, K extends keyof QueryWhereMap<E>>(entity: Type<E>, key: K, val: QueryWhereMap<E>[K], opts?: QueryComparisonOptions): string;
    compareFieldOperator<E, K extends keyof QueryWhereFieldOperatorMap<E>>(entity: Type<E>, key: FieldKey<E>, op: K, val: QueryWhereFieldOperatorMap<E>[K], opts?: QueryOptions): string;
    escape(value: any): Scalar;
}
